function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useContext } from 'react';
import { ThemeProvider } from '@material-ui/core/styles';
import getThemeSource from 'material-ui-shell/lib/utils/theme';
import ConfigContext from 'base-shell/lib/providers/Config/Context';
import ThemeContext from 'material-ui-shell/lib/providers/Theme/Context';
import CssBaseline from '@material-ui/core/CssBaseline';
import PWAPrompt from 'react-ios-pwa-prompt';
import { useIntl } from 'react-intl';
import UpdateContext from 'base-shell/lib/providers/Update/Context';
export default function (_ref) {
  var children = _ref.children;
  var intl = useIntl();

  var _useContext = useContext(ConfigContext),
      appConfig = _useContext.appConfig;

  var _ref2 = appConfig || {},
      components = _ref2.components;

  var _ref3 = components || {},
      _ref3$UpdateDialog = _ref3.UpdateDialog,
      UpdateDialog = _ref3$UpdateDialog === void 0 ? null : _ref3$UpdateDialog;

  var _useContext2 = useContext(UpdateContext),
      isUpdateAvailable = _useContext2.isUpdateAvailable,
      runUpdate = _useContext2.runUpdate;

  var _useContext3 = useContext(ThemeContext),
      themeID = _useContext3.themeID,
      type = _useContext3.type;

  var _ref4 = appConfig || {},
      themeConfig = _ref4.theme,
      pwa = _ref4.pwa;

  var _ref5 = pwa || {},
      useiOSPWAPrompt = _ref5.useiOSPWAPrompt,
      iOSPWAPromptProps = _ref5.iOSPWAPromptProps,
      useUpdateDialog = _ref5.useUpdateDialog;

  var _ref6 = themeConfig || {},
      _ref6$themes = _ref6.themes,
      themes = _ref6$themes === void 0 ? [] : _ref6$themes;

  var theme = getThemeSource(themeID, themes, type);
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React.createElement(CssBaseline, null), children, useUpdateDialog && /*#__PURE__*/React.createElement(UpdateDialog, {
    isUpdateAvailable: isUpdateAvailable,
    runUpdate: runUpdate
  }), useiOSPWAPrompt && /*#__PURE__*/React.createElement(PWAPrompt //debug={true}
  , _extends({
    promptOnVisit: 1,
    timesToShow: 3,
    copyTitle: intl.formatMessage({
      id: 'ios_prompt_title',
      defaultMessage: 'Add to Home Screen'
    }),
    copyClosePrompt: intl.formatMessage({
      id: 'ios_prompt_close',
      defaultMessage: 'Close'
    }),
    copyBody: intl.formatMessage({
      id: 'ios_prompt_body',
      defaultMessage: 'This website has app functionality. Add it to your home screen to use it in fullscreen and while offline.'
    }),
    copyShareButtonLabel: intl.formatMessage({
      id: 'ios_prompt_share_button',
      defaultMessage: "1) Press the 'Share' button"
    }),
    copyAddHomeButtonLabel: intl.formatMessage({
      id: 'ios_prompt_add_to_home_button',
      defaultMessage: "2) Press 'Add to Home Screen'"
    }),
    permanentlyHideOnDismiss: false
  }, iOSPWAPromptProps)));
}