"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles = require("@material-ui/core/styles");

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Menu = _interopRequireDefault(require("@material-ui/icons/Menu"));

var _reactIntl = require("react-intl");

var _Context = _interopRequireDefault(require("base-shell/lib/providers/Online/Context"));

var _Context2 = _interopRequireDefault(require("material-ui-shell/lib/providers/Menu/Context"));

var _LinearProgress = _interopRequireDefault(require("@material-ui/core/LinearProgress"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _Context3 = _interopRequireDefault(require("base-shell/lib/providers/Config/Context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    root: {
      width: '100%',
      display: 'flex',
      flexDirection: 'column',
      height: '100vh',
      overflow: 'hidden'
    },
    appBar: {
      zIndex: theme.zIndex.drawer + 1,
      transition: theme.transitions.create(['width', 'margin'], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      }),
      maxHeight: 64
    },
    appBarShift: {
      width: function width(props) {
        return "calc(100% - " + props.width + "px)";
      },
      transition: theme.transitions.create(['width', 'margin'], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.enteringScreen
      })
    },
    menuButton: {
      marginLeft: -12
    },
    hide: {
      display: 'none'
    },
    toolbar: _extends({
      alignItems: 'center',
      justifyContent: 'flex-end'
    }, theme.mixins.toolbar),
    offlineIndicator: {
      position: 'absolute',
      display: 'flex',
      alignItems: 'center',
      backgroundColor: theme.palette.secondary.main,
      justifyContent: 'center',
      right: 0,
      left: 0,
      height: function height(props) {
        return props.offlineIndicatorHeight;
      }
    },
    content: {
      flex: 1,
      overflow: 'auto'
    },
    grow: {
      flex: '1 1 auto'
    }
  };
});

var Page = function Page(_ref) {
  var children = _ref.children,
      pageTitle = _ref.pageTitle,
      onBackClick = _ref.onBackClick,
      isLoading = _ref.isLoading;
  var isOnline = (0, _react.useContext)(_Context.default);
  var theme = (0, _styles.useTheme)();

  var _useContext = (0, _react.useContext)(_Context3.default),
      appConfig = _useContext.appConfig;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      _ref3$width = _ref3.width,
      width = _ref3$width === void 0 ? 240 : _ref3$width,
      _ref3$offlineIndicato = _ref3.offlineIndicatorHeight,
      offlineIndicatorHeight = _ref3$offlineIndicato === void 0 ? 12 : _ref3$offlineIndicato;

  var _useContext2 = (0, _react.useContext)(_Context2.default),
      isDesktop = _useContext2.isDesktop,
      isDesktopOpen = _useContext2.isDesktopOpen,
      setDesktopOpen = _useContext2.setDesktopOpen,
      isMobileOpen = _useContext2.isMobileOpen,
      setMobileOpen = _useContext2.setMobileOpen,
      setMini = _useContext2.setMini;

  var intl = (0, _reactIntl.useIntl)();
  var headerTitle = '';

  if (typeof pageTitle === 'string' || pageTitle instanceof String) {
    headerTitle = pageTitle;
  }

  var classes = useStyles({
    width,
    offlineIndicatorHeight
  });

  var handleDrawerMenuClick = function handleDrawerMenuClick() {
    if (!isDesktopOpen) {
      setMini(false);
      setDesktopOpen(true);

      if (!isDesktop) {
        setMobileOpen(!isMobileOpen);
      }
    } else {
      setMobileOpen(!isMobileOpen);
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: classes.root
  }, /*#__PURE__*/_react.default.createElement(_AppBar.default, {
    position: isDesktop ? 'absolute' : undefined,
    className: isDesktop ? (0, _clsx.default)(classes.appBar, isDesktopOpen && classes.appBarShift) : classes.appBar
  }, /*#__PURE__*/_react.default.createElement(_Toolbar.default, null, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: handleDrawerMenuClick,
    edge: "start",
    className: (0, _clsx.default)(classes.menuButton, isDesktopOpen && isDesktop && classes.hide, onBackClick && classes.hide)
  }, /*#__PURE__*/_react.default.createElement(_Menu.default, null)), /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: onBackClick,
    className: (0, _clsx.default)(classes.menuButton, !onBackClick && classes.hide)
  }, /*#__PURE__*/_react.default.createElement(_ChevronLeft.default, null)), !onBackClick && isDesktopOpen && false && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      marginRight: 32
    }
  }), /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "h6",
    color: "inherit",
    noWrap: true
  }, headerTitle), /*#__PURE__*/_react.default.createElement("div", {
    className: classes.grow
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: classes.toolbar
  }), isLoading && /*#__PURE__*/_react.default.createElement(_LinearProgress.default, null), !isOnline && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      width: '100%',
      height: 15,
      backgroundColor: theme.palette.secondary.main
    }
  }, /*#__PURE__*/_react.default.createElement(_Typography.default, {
    variant: "caption",
    color: "textSecondary",
    noWrap: true
  }, intl.formatMessage({
    id: 'offline',
    defaultMessage: 'Offline'
  }))), /*#__PURE__*/_react.default.createElement("main", {
    className: classes.content
  }, children));
};

var _default = Page;
exports.default = _default;
module.exports = exports.default;